
/* ***************************************************************************************/
// Linear Algebra Problem "Guass Elimination" for matrix of size [N x N+1]               //
// This programe is the solution for Guass Elimination and Back substitution             //	 
// Problem using Parallel Processing platform "MPJ-Express".(Author: Amir Shafi,         //
// Bryner carpenter, Mark Baker)                                                         //
// ------------------------------------------------------------------------------------- //
// Author : Bibrak Qamar 2007-NUST-BIT9-106                                              //
//                      and                                                              //
//          Jahanzeb Maqbool 2007-NUST-BIT9-118                                          //
// NUST School of Electrical Engineering and computer Science.                           //
// 			          PAKISTAN                                                           //
/* ************************************************************************************* */
/* ------------------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------------------
 
How to use the program ...............................................................
1- The String variable WDIR, must have the path to the directory where you are 
   storing your files, where WDIR must be accessible to every node (processor) 
2- In the input_size.txt write the number of rows( linear equations ) and press enter
   to give a '\n' ..... :)

2- The input size must be perfectly divisibile by the number of processors.

3- The input size must be greater than number of processors.
   processors must be greater than 1.


---------------------------------------------------------------------------------------- */

import mpi.*;
import java.io.*;
import javax.swing.*;
import java.text.DecimalFormat;



public class guass{
	
	  String WDIR = "/media/Academics/Academic/Research/HPC/mpj/pro/Algo-Java Project/implementation";
	  private FileWriter fw;
      private BufferedWriter bw;
	  private PrintWriter pw;
	  private BufferedReader   inputStream = null; 
	  private PrintWriter      outputStream = null;
	
 
	public String ReadInput(){ // this function returns the number of rows ( size or the number of linear variables ) from file input_size.txt
			String SIZE= null;		
		
			try{
	
		inputStream = new BufferedReader(new FileReader(WDIR+"/input_size.txt"));
		SIZE = inputStream.readLine();
	//	WDIR = inputStream.readLine();
			if(inputStream != null)
			{		
				inputStream.close();
			}
		}catch(Exception e){System.out.println(e); };
		
		return SIZE;

	}

	 public void reBuild (int size) // once every processor ends submitting their result in file rank.txt this function collectes the info
									// and rebuilds the splited matrix
	 {
	 	String l="";
	 	try {
	 		 outputStream = new PrintWriter(new FileWriter(WDIR+"/Final_Result.txt"));  	
	 		 for (int i=0; i< size; i++ )
	 		 {
	 		 	 inputStream = new BufferedReader(new FileReader(WDIR+"/"+i+".txt"));
			 	 while ((l = inputStream.readLine()) != null) 
			 	 { 
					outputStream.println(l); 
			 	 }
	 		 }
	 		 if (inputStream != null) 
			 {
			 	 inputStream.close();
			 }
			 if (outputStream != null) 
			 {
			 	 outputStream.close();
			 } 
		} catch (Exception e) {System.out.println(e);}	
		
	} 

		public void writer (double arr[], int n , int rank ) // this function writes the rows to a file rank.txt here rank is the integer value
															// every processor has some part of the matrix
		{
			try{    		
    	 	  	 fw = new FileWriter (WDIR+"/"+rank+".txt",true);
    			 bw = new BufferedWriter (fw);
    			 pw = new PrintWriter (bw);
    		}catch (Exception e){System.out.println(e);}
    
    	    String writer="";
    		for (int j=0; j<n; j++)
    		{
    			writer+= arr[j]+"\t\t";	
    		}
    		pw.println(writer);
    		pw.close();	
	}

	public void Statistics (double time_T, int N , int P)
		{
			try{    		
    	 	  	 fw = new FileWriter (WDIR+"/Statistics.txt",true);
    			 bw = new BufferedWriter (fw);
    			 pw = new PrintWriter (bw);
    		}catch (Exception e){System.out.println(e);}
    
    	    //String writer="";
    		pw.println("The time taken was : "+time_T+" sec When processors were = "+P+" and Linear equations were = "+N);
    		//pw.println(writer);
    		pw.close();	
	}
	
	//******//******//******//******//******//******//******//******//******//******
	
	public static void main(String []arg)
	{
		guass obj = new guass();  // class object
		
		MPI.Init(arg);
		
		int []messenger = new int [1];  // used to send the input size to all processors
		int rank; 						// rank of current processor
		int peer; 					    // used in Send Recv function, 
		int tag; 
		int size;	 					// total number of processors
		int zeroer;  					// position of the element where 0 has to be made in the matrix
		int N=0;  						// the input size, # of rows
		double Row[][]; 				// here every processor will have its part of the matrix
		double temp[]; 					// temporary , used in Send Recv functions
		double m; 						// multiplicant
		int D;   						// D is the division as how many rows will the nodes(processors) get
		DecimalFormat twoDForm = new DecimalFormat("#.##"); // ( used to represent value in 2 decimal points
		double t1=0,t2=0,time_total=0;  // used to calculate the running time
		rank = MPI.COMM_WORLD.Rank();   // rank allocated...
		size = MPI.COMM_WORLD.Size();	// no of processors....
		  t1 = System.currentTimeMillis();
		
		if (rank == 0)
		{
			      		String input =null;
			
			//	String in= JOptionPane.showInputDialog("Enter N : ");
			//	messenger[0] = Integer.parseInt(in); 						
			//	N = messenger[0];
				//System.out.println(arg[0]+" 2nd = "+arg[1]+" 3rd = "+arg[2]);
			/*	
				BufferedReader InFromUser = new BufferedReader( new InputStreamReader(System.in));
				try{
				System.out.println("N = ? ");
				input = InFromUser.readLine();	}
				catch(IOException ex ){System.out.println(ex); }
			*/
				input = obj.ReadInput(); // reading the size of rows from file
				messenger[0] = Integer.parseInt(input); // passing input to the array then it will be sent as size to each node. 
				N = messenger[0];
				//messenger[0] = N;
				MPI.COMM_WORLD.Send(messenger,0,1,MPI.INT,rank+1,rank); // telling every processor the total size of the matrix
							
			// send the size to all
			D = N/size; // how many rows this processor keeps, here N must be perfectly divisible by size
			System.out.println("Every processor gets  "+D+" rows");
			Row = new double[D][N+1];  
			zeroer = 0;	// starting from first element to make it zero, but in case of rank == 0 this will not happen, as u know Linear Algebra
			// populate the row(s) here I will use randam numbers, (OR from file the values can also be fetched )
			
			for(int pop_row = 0 ; pop_row<D ; pop_row++)
				for(int  pop_col = 0 ; pop_col<N+1; pop_col++)
				{
					
					Row[pop_row][pop_col] = Double.valueOf(twoDForm.format((double)(Math.random() * 20)));
					
				}
				int i=0;int j=0;
				for( i = 0 ; i<D;i++) // there send D rows and also perform operations on them
				{
					MPI.COMM_WORLD.Send(Row[i],0,N+1,MPI.DOUBLE,rank+1,rank); // send ith row to every processor
					System.out.println("Row # "+i+" sent by processor "+rank);
					for( j = i+1; j<D; j++)
					{
						m = Row[j][zeroer] / Row[i][zeroer];
						// find the multipier for row[j] with respect to row[i]
							for(int k = zeroer ; k<N+1; k++)
							{
							Row[j][k] = Double.valueOf(twoDForm.format(Row[j][k] - Row[i][k] * m )); // basic maths to make zeroer(th) index zero
							}
					}
					zeroer++;
				}
				
				i--;
				if(size > 1 ){		// if we have more than 1 processors, then send the last row to the next preceeding processors
				MPI.COMM_WORLD.Send(Row[i],0,N+1,MPI.DOUBLE,rank+1,rank); // send the last row
					System.out.println("Row sent by processor "+rank);
				}
		}
		
		else // for the processors where rank>0
		{
			 //set the value of N
			
			 // Recieving and sending size of variables .... 
			
			MPI.COMM_WORLD.Recv(messenger,0,1,MPI.INT,rank-1,rank-1);
			
			if (rank != size-1)
			{
				MPI.COMM_WORLD.Send(messenger,0,1,MPI.INT,rank+1,rank); // send the input_size ( number of rows) to the imediate next processor
				
			}
			N=messenger[0];
			D = N/size;
			System.out.println("D = "+D);
			Row = new double[D][N+1];
			temp = new double[N+1];
			
			zeroer = 0;	
				
			for(int pop_row = 0 ; pop_row<D ; pop_row++)
				for(int  pop_col = 0 ; pop_col<N+1; pop_col++)
				{
					
					Row[pop_row][pop_col] = Double.valueOf(twoDForm.format((double)(Math.random() * 20)));
					
				}
				System.out.println("Starting operations on "+rank);

			// Recv D rows from processors , where rank> them, if rank == 3, Recv from 0,1,2, but the Algorithm is writen in such
											// a way that rank ==3 can only recv from rank ==2
											// rank 2 from rank 1 and rank 1 from rank 0

			for(int R = 0 ; R<rank ; R++) // recv from all the processors which are before him, in order -> 0,1 ,2, 3 ,4 ....| me
			{
				System.out.println("Recieving process started on processor "+rank);
				for(int i = 0; i<D ; i++)
				{
					//System.out.println("Going to recv by "+rank);
					MPI.COMM_WORLD.Recv(temp,0,N+1,MPI.DOUBLE,rank-1,rank-1); // send to imediate next,
					System.out.println("Row Recv by processor "+rank);
					if(rank != size-1)
					{
						MPI.COMM_WORLD.Send(temp,0,N+1,MPI.DOUBLE,rank+1,rank); // in this way we can braodcast the rows
						System.out.println("Row sent by processor "+rank);
					}
					
					// opeating on its own rows w.r.t temp row (received from the last proc)
					
					
					for(int j = 0; j<D; j++)	// same loop as in head, but there it started from i+1 bcz here it has to operate on 1st row.
					{
						// find the matiplier for row[j] with respect to row[i]
						m = Row[j][zeroer] / temp[zeroer];
						for(int k = zeroer ; k<N+1; k++)
						{
							Row[j][k] = Double.valueOf(twoDForm.format(Row[j][k] - temp[k] * m ));
						}
					}	
					zeroer++;	
				}
				
			}
			
	
		//************** NOW MY TURN TO SEND ! ! ! **************//        
        // here each processor has to send his own row to the next processors and performs
        // operations on its own rows wrt its own row, bcz in above statements it was sending
        // the temp row to nxt processors and was operating on its own wrt to temp (came from prev proc.)
        	
			int i=0;
			int j=0; 
		
			// there send D rows and also perform operations on them
			for( i = 0 ; i<D;i++) 
			{					
				if(rank != (size - 1) )
				{
					MPI.COMM_WORLD.Send(Row[i],0,N+1,MPI.DOUBLE,rank+1,rank);
					System.out.println("Row sent by processor "+rank);
				}		
				for( j = i+1; j<D; j++)
				{
					System.out.println("operating on row "+(j+(D*rank))+" by processor "+rank);
					// find the matiplicant for row[j] with respect to row[i]
					m = Row[j][zeroer] / Row[i][zeroer];
					for(int k = zeroer ; k<N+1; k++)
					{
						Row[j][k] =Double.valueOf(twoDForm.format( Row[j][k] - Row[i][k] * m)) ;
					}
				}
					zeroer++;
			}
		
			if (rank != (size - 1))  	// send to rest of the processes
			{
				i--;
				MPI.COMM_WORLD.Send(Row[i],0,N+1,MPI.DOUBLE,rank+1,rank);
					System.out.println("Row sent by processor "+rank);
			}
	} 				//else for rank!=0 ends

	// Till here we have our matrix in upper tringular form, excluding the last column where the constants are strored  [N][N+1] the Nth index in array
		
		
	//********************              Back Substitution 				//********************

		
		double backTemp[] = new double[1];
	//	peer = size-1;
		int k = N-1;
		
		System.out.println("Going to recv back in rank "+rank);
			
	for(int Recv = 0 ; Recv< ( size- rank - 1); Recv++) // Recv the values of variles which have been calculated, 
								// in the begining we have the value of last variable
	{
	
			for (int row =D-1 ; row >=0 ; row --)// start from last row
			{
				//System.out.println("in recv back and before recv backtemp ");
			     MPI.COMM_WORLD.Recv(backTemp,0,1,MPI.DOUBLE,rank+1,rank+1);
			     
			     //	System.out.println("value of backTemp is  "+backTemp[0]);
			     
			     if(rank != 0){
			 //    	System.out.println("send part of recv ");
			     	
			     	MPI.COMM_WORLD.Send(backTemp,0,1,MPI.DOUBLE,rank-1,rank); // propagate the row
			     	
			     }
		          
		         System.out.println("Back sub on column = "+k);
		          for(int col = D-1 ; col>=0; col--){ // perform operation on rows cal k, here k is the pointer which points the index 
								// which has to be made zero
		          	
		          	Row[col][k] *= backTemp[0];
		          	Row[col][N] -= Row[col][k];
				
		          	Row[col][k] = 0;
		          	
		          }
		          k--;		
		}
	}//	peer--;
		
		System.out.println("After recv back and now going to send in rank "+rank);
			//	{
			//for(int Send = 0  ; Send < rank  ; Send++){
			//if(rank != 0)
			//{
			  	for (int row =D-1 ; row >=0 ; row --)

			  	{
			  		Row[row][N] /=Row[row][k];
			  		Row[row][k] = 1;
			  		backTemp[0] = Row[row][N];
			  			System.out.println("value of backtemp = "+backTemp[0]+" in rank = "+rank);
			  		
				if(rank != 0){
			  		
					MPI.COMM_WORLD.Send(backTemp,0,1,MPI.DOUBLE,rank-1,rank);
				}
			  //   System.out.println("In Send back loop Send = "+Send+" in rank "+rank);
		          for(int col = row-1 ; col>=0; col--){
		          	System.out.println("In Send back loop col = "+col+" in rank "+rank);
		          	Row[col][k] *= backTemp[0];
		          	Row[col][N] -= Row[col][k];
		          	Row[col][k] = 0;
		          	
		          }
		          k--;
			  	}		
		//}	
		
	
//********************//********************//********************//********************		
		        

		MPI.Finalize();		// stop the IPC
		
		 t2 = System.currentTimeMillis(); // calculate the running time and store it in the Statistics.txt
			time_total = (t2 - t1)/1000;
			if(rank == 0 ){
			
			obj.Statistics(time_total,N,size);

			}


		
		//******  Each Processor is going to write its work on a seperate file... ******//
		
		for(int w = 0; w<D;w++)
		{
		    obj.writer (Row[w], N+1 , rank);
		}
		
		//******  At head node, Final Result file is rebult from different files containing 
		//****** tasks done by each processor...
		
		if (rank==0)
		{
			obj.reBuild(size); // the head note has to compile the contributions, and store the final result in a file
		
		}
		
	
		
	}	// main method ends here
		
}		// guass class ends here .... 
